<?php
declare(strict_types=1);

namespace Flat101\MultiWidget\Api;

use Flat101\MultiWidget\Api\Data\TypesInterface;
use Magento\Framework\Exception\NoSuchEntityException;

interface TypesRepositoryInterface
{
    /**
     * Save Types
     *
     * @param TypesInterface $types
     * @return TypesInterface
     */
    public function save(TypesInterface $types): TypesInterface;

    /**
     * Retrieve entity by id
     *
     * @param int $entityId
     * @return TypesInterface
     * @throws NoSuchEntityException
     */
    public function getById(int $entityId): TypesInterface;

    /**
     * Retrieve Types by attribute
     *
     * @param $value
     * @param string|null $attributeCode
     * @return TypesInterface
     * @throws NoSuchEntityException
     */
    public function get($value, ?string $attributeCode): TypesInterface;
}
