<?php
declare(strict_types=1);

namespace Flat101\MultiWidget\Controller\Adminhtml\KeyBenefits;

use Flat101\MultiWidget\Api\Data\ItemsInterface;
use Flat101\MultiWidget\Api\Data\MultiWidgetInterface;
use Flat101\MultiWidget\Controller\Adminhtml\AbstractController\Save AS AbstractSave;
use Magento\Framework\Exception\LocalizedException;

class Save extends AbstractSave
{
    /**
     * Inherit
     */
    public function deleteRemovedItems(MultiWidgetInterface $multiWidget, array $itemsIds)
    {
        //Remove items
        foreach ($this->getItemsCollection($multiWidget) as $item) {
            /** @var ItemsInterface $item */
            if (!in_array($item->getId(), $itemsIds)) {
                try {
                    $this->fileEraser->removeImage($item, Upload::KEYBENEFITS_IMAGE_PATH_DESTINATION);
                    $this->itemsRepository->delete($item);
                } catch (LocalizedException $e) {
                    $this->messageManager->addErrorMessage('There was an error deleting Slides: ' . $e->getMessage());
                } catch (\LogicException $e) {
                    $this->messageManager->addErrorMessage($e->getMessage());
                }
            }
        }
    }
}
