# Multi Widget M2 Module by Flat 101

## Starting 🚀

Multi Widget is a module that tries to standardize several features that we think almost each
all projects have like Key Benefits and Sliders.

This module could be more completed, and we will try to add new features/entities to the base module.

#### BASE ENTITIES

- Key Benefits
- Sliders

## Installation

Use the package manager Composer to install module from the Flat 101's private package repository.

First, you need to add the Flat 101's private package repository to the project. Once the 
repository has been added:  

```bash
composer require flat101/multi-widget
```

```bash
bin/magento setup:upgrade
bin/magento setup:di:compile
bin/magento cache:clean
```

## Add new entities

We can add new entities with purpose to complete the module or by a requirement from new project.
It will be very simple and quickly. You can see other entities to replicate folders and files and 
adjust with fields you need for the new entity. To add a new entity we need to follow this steps:

#### DATABASE

- Add to database table 'flat101_multiwidget_type' a new row. We only need a name. Take in mind 
  that ID number is very important in the next steps. It is mandatory to add a Data Patch for stable
  new entities.

#### ADMIN PANEL

- Create a new menu item. Edit file Flat101/MultiWidget/etc/adminhtml/menu.xml
- Create new controller's folder in Flat101/MultiWidget/Controller. Exists folder AbstractController
  for help you. See other controller folder to see actions. Review folder structure.
- Create layouts for this controllers in Flat101/MultiWidget/view/adminhtml/layout.
- Create UI Components for listing and forms in Flat101/MultiWidget/view/adminhtml/ui_component.
  Here, you need ID number from 'flat101_multiwidget_type' to filter results in listing.
- Create DataProvider for UI component in Flat101/MultiWidget/Model/MultiWidget.
- Create UI Component actions for listing in Flat101/MultiWidget/UI/Component/Listing/Columns.
- Create button functionalities in Flat101/MultiWidget/Block/adminhtml. Review folder structure.
- Create new widget form for entity in Flat101/MultiWidget/etc/widget.xml.

#### FRONTEND

- Add templates for widget in Flat101/MultiWidget/view/frontend/widget. Review folder structure.

## Usage

Navigate to the menu corresponding to the entity. There you will find the necessary options for CRUD.

## Contributions
Pull requests are welcome. For major changes, please open an issue first to discuss what you would 
like to change.

## Authors

* **Juan Antonio Licer** - Flat 101 Team
